#include <X11/Xlib.h> 

int LIMIT=3;
int LIMIT2=3;
int GLIMIT=40;
int WLIMIT=12;

extern int GAME,PANIC;

int COUNTER=0,GCOUNTER=0,WAIT=0,SCORE=0,LINES=0,LEVEL=0;
int GLIMIT_BY_LEVEL[10] = { 512, 256, 128, 64, 32, 16, 8, 4, 2, 1 };

unsigned char board[10][20];
unsigned char LEFT=0,RIGHT=0,DOWN=0,LEFT_OLD=0,RIGHT_OLD=0,DOWN_OLD=0;

int X,Y,PIECE,PHASE=0,NEXT;

void NextPiece();

int random_piece()
{
        /* in a perfect world, these seven numbers would be equal :-) */
        int analogia[7]={4,3,3,2,2,3,3};
        int total,number;
        register int i;

        total=0;
        for (i=0; i<7; i++) total+=analogia[i];
        number=rand()%total;
        for (i=0; i<6; i++)
        {
                if (number < analogia[i]) return (i+1);
                number-=analogia[i];
        }
        return 7;
}

void clear_board()
{
	int i,j;

	for (i=0; i<10; i++)
	for (j=0; j<20; j++)
	board[i][j]=0;
}

void dump_piece(Display *disp,Window win,GC gc,XFontStruct *font)
{
	int i,j,k,ok,lines=0;
	int line[20];
	unsigned char new_board[10][20];

	for (i=0; i<5; i++)
	for (j=0; j<5; j++)
	if (bit_of_piece(PIECE,j,i,PHASE) == 'x') board[X+j][Y+i]=PIECE;

	for (i=0; i<20; i++)
	{
		line[i]=1;
		for (j=0; j<10; j++) if (!board[j][i]) line[i]=0;
		if (line[i]) { SCORE++; lines++; }
	}

	if (SCORE/10 > LEVEL && LEVEL < 9)
	{
		LEVEL=SCORE/10;
		GLIMIT=GLIMIT_BY_LEVEL[LEVEL];
		draw_level(disp,win,gc);
		if (LEVEL == 9)
		{
			draw_panic(disp,win,gc,1);
			PANIC=1;
		}
	}

	if (lines) FlashLines(disp,win,gc,line);

	for (i=0; i<20; i++)
	for (j=0; j<10; j++)
	new_board[j][i]=0;

	for (i=19,j=19; i>=0; i--)
	{
		if (!line[i])
		{
			for (k=0; k<10; k++) new_board[k][j]=board[k][i];
			j--;
		}
	}
        for (i=0; i<20; i++)
        for (j=0; j<10; j++)
        board[j][i]=new_board[j][i];
        DrawGameBoard(disp,win,gc);

	XSync(disp,False);

	draw_score(disp,win,gc);

	NextPiece(disp,win,gc,font);
}

void NextPiece(Display *disp,Window win,GC gc,XFontStruct *font)
{
	int i,j,ok;

	PIECE=NEXT;
	NEXT=random_piece();

	X=2;
	Y=-4;
	PHASE=0;
	do
	{
		Y++;
		ok=1;
		for (i=0; i<5; i++)
		for (j=0; j<5; j++)
		if (bit_of_piece(PIECE,j,i,PHASE) == 'x' && Y+i < 0) ok=0;
	}
	while (!ok);

	DrawCurrentPiece(disp,win,gc,1);
	DrawNext(disp,win,gc);

	ok=1;
	for (i=0; i<5; i++)
	for (j=0; j<5; j++)
	if (bit_of_piece(PIECE,j,i,PHASE) == 'x' && board[X+j][Y+i]) ok=0;
	if (!ok)
	{
		GAME=0;
		show_message(disp,win,gc,font,"Press 'S' to start game",1);
	}

	XSync(disp,False);
}

void move_left(Display *disp,Window win,GC gc)
{
	int i,j,ok=1;

	X--;
	for (i=0; i<5; i++)
	for (j=0; j<5; j++)
	if (bit_of_piece(PIECE,j,i,PHASE) == 'x')
	{
		if (X+j < 0 || X+j > 9 || Y+i < 0 || Y+i > 19) ok=0; else
		if (board[X+j][Y+i]) ok=0;
	}
	X++;
	if (ok)
	{
		DrawCurrentPiece(disp,win,gc,0);
		X--;
		DrawCurrentPiece(disp,win,gc,1);
		XSync(disp,False);
	}
}

void move_right(Display *disp,Window win,GC gc)
{
        int i,j,ok=1;

        X++;
        for (i=0; i<5; i++)
        for (j=0; j<5; j++)
        if (bit_of_piece(PIECE,j,i,PHASE) == 'x')
        {
                if (X+j < 0 || X+j > 9 || Y+i < 0 || Y+i > 19) ok=0; else
                if (board[X+j][Y+i]) ok=0;
        }
	X--;
        if (ok)
        {
                DrawCurrentPiece(disp,win,gc,0);
                X++;
                DrawCurrentPiece(disp,win,gc,1);
		XSync(disp,False);
        }
}

void move_down(Display *disp,Window win,GC gc,XFontStruct *font)
{
        int i,j,ok=1;

        Y++;
        for (i=0; i<5; i++)
        for (j=0; j<5; j++)
        if (bit_of_piece(PIECE,j,i,PHASE) == 'x')
        {
                if (X+j < 0 || X+j > 9 || Y+i < 0 || Y+i > 19) ok=0; else
                if (board[X+j][Y+i]) ok=0;
        }
	Y--;
        if (ok)
        {
                DrawCurrentPiece(disp,win,gc,0);
                Y++;
                DrawCurrentPiece(disp,win,gc,1);
		XSync(disp,False);
	}
	  else
	{
		if (WAIT++ < LIMIT) return;
		WAIT=0;
		dump_piece(disp,win,gc,font);
	}
}

void do_gravity(Display *disp,Window win,GC gc,XFontStruct *font)
{
	int i,j,ok=1;

	if (GCOUNTER++ < GLIMIT) return;
	GCOUNTER=0;

        Y++;
        for (i=0; i<5; i++)
        for (j=0; j<5; j++)
        if (bit_of_piece(PIECE,j,i,PHASE) == 'x')
        {
                if (X+j < 0 || X+j > 9 || Y+i < 0 || Y+i > 19) ok=0; else
                if (board[X+j][Y+i]) ok=0;
        }
        Y--;
        if (ok)
        {
                DrawCurrentPiece(disp,win,gc,0);
                Y++;
                DrawCurrentPiece(disp,win,gc,1);
                XSync(disp,False);
        }
          else
        {
                if (WAIT++ < LIMIT) return;
                WAIT=0;
                dump_piece(disp,win,gc,font);
        }
}

void rotate_piece(Display *disp,Window win,GC gc)
{
        int i,j,ok=1;

	PHASE=(PHASE+1)%4;
        for (i=0; i<5; i++)
        for (j=0; j<5; j++)
        if (bit_of_piece(PIECE,j,i,PHASE) == 'x')
        {
                if (X+j < 0 || X+j > 9 || Y+i < 0 || Y+i > 19) ok=0; else
                if (board[X+j][Y+i]) ok=0;
        }
	PHASE=(PHASE+3)%4;
        if (ok)
        {
                DrawCurrentPiece(disp,win,gc,0);
		PHASE=(PHASE+1)%4;
                DrawCurrentPiece(disp,win,gc,1);
                XSync(disp,False);
        }
}

void rock_bottom(Display *disp,Window win,GC gc,XFontStruct *font)
{
	int i,j,ok,OLD_Y,NEW_Y;

	OLD_Y=Y;

	do
	{
		Y++;
		ok=1;
       		for (i=0; i<5; i++)
	        for (j=0; j<5; j++)
	        if (bit_of_piece(PIECE,j,i,PHASE) == 'x')
	        {
	                if (X+j < 0 || X+j > 9 || Y+i < 0 || Y+i > 19) ok=0; else
	                if (board[X+j][Y+i]) ok=0;
	        }
	}
	while (ok);

	NEW_Y=Y-1;
	Y=OLD_Y;
	DrawCurrentPiece(disp,win,gc,0);
	Y=NEW_Y;
	DrawCurrentPiece(disp,win,gc,1);
	GCOUNTER=0;
	WAIT=0;
	dump_piece(disp,win,gc,font);
}
